; ------------------------------------------------------------------
; Tunnel Of Glitch
; Doesn't look proper for faster machine than a bog standard Amiga
; as the glitches rely on the speed of the processor.
; ------------------------------------------------------------------
; Written by hitchhikr/Rebels
; ------------------------------------------------------------------

; ------------------------------------------------------------------
_LVOClearScreen         equ     -48
_LVOText	            equ	    -60 
_LVOInitRastPort        equ     -198
_LVOMove                equ     -240 
_LVOPolyDraw            equ     -336 

SCREEN_X                equ     320
SCREEN_Y                equ     SCREEN_X
SCREEN_BYTES            equ     (SCREEN_X/8)

RastPort                equ     0
rp_BitMap               equ     RastPort+4
rp_LinePtrn             equ     RastPort+34

; ------------------------------------------------------------------
                        dc.l    $000003f3
                        dc.l    $00000000
                        dc.l    $00000001
                        dc.l    $00000000
                        dc.l    $00000000
                        ; This one can be bigger than the
                        ; actual section so the OS
                        ; will allocate a bigger memory block
                        ; for it (and zero it under 2.0+)
                        dc.l    ((fin-start)>>2)|$40000000
                        dc.l    $000003e9
                        dc.l    (fin-start)>>2

; ------------------------------------------------------------------
start:
                        move.l  4.w,a6
                        move.l  156(a6),a6                      ; gfxbase
                        lea		(a2),a1                         ; somewhere in memory
                        jsr     _LVOInitRastPort(a6)
                        lea		(a2),a1                         ; a1 is trashed on 2.0+
                        lea     $dff006,a5
                        lea     copperlist(pc),a2
                        move.l  a2,$80-6(a5)
                        pea     $60000                          ; frame buffer address
                        lea		(a7),a2
                        swap    d4                              ; d4 is always 1
                        move.l  d4,-(a7)                        ; 1 bp
                        move.l  #(SCREEN_BYTES<<16)+SCREEN_Y,-(a7)
                        move.l  a7,rp_BitMap-RastPort(a1)

; ------------------------------------------------------------------
                        moveq   #80,d5
main_loop:
                        cmp.b   #255,(a5)
                        bne.b   main_loop
                        eor.w   #1,(a2)                         ; $60000 or $70000
                        jsr		_LVOClearScreen(a6)
                        moveq   #9-1,d6
                        ; actually the start of the executable
                        move.w  (a3),d2
create_squares:
                        lea     (a3),a0
                        ; positive/negative coords bits
                        moveq   #%0001111000,d3
                        moveq   #5-1,d7
create_coords:
                        bsr.b   calc_persp
                        bsr.b   calc_persp
                        ; bring the mayhem
                        move.w  (a5),$110-6(a5)
                        dbf     d7,create_coords
                        ; bring the noise
                        divs.w  (a5),d0
                        ; set lines pattern filling
                        move.w  d0,rp_LinePtrn-RastPort(a1)
                        ; bring more mayhem
                        add.w   d0,$102-6(a5)
                        sub.w   d0,$182-6(a5)
                        move.w  (a5),$110-6(a5)
                        ; draw 5 lines
                        ; (5 are needed to properly close a square
                        ;  to loop back to the first streamed coords)
                        movem.w (a0),d0/d1
                        jsr     _LVOMove(a6)
                        moveq   #5,d0
                        jsr     _LVOPolyDraw(a6)
                        add.w   d5,d2
                        dbf     d6,create_squares
                        ; necessary on 2.0+
                        moveq   #0,d0
                        jsr     _LVOMove(a6)

                        ; i like to move it
                        asr.w   #8,d2                           ; add some speed variations
                        sub.w   d2,(a3)
                        bgt.b   reset_zoom
                        move.w  d5,(a3)
reset_zoom:
                        ; only set the upper part of the bitplane
                        ; for double buffering purposes
                        move.w  (a2),$e0-6(a5)
                        bra.b   main_loop
calc_persp:
                        ; either $2700...
                        move.w  #39<<8,d0
                        cmp.w   #62,d2
                        blt.b   max_zoom
                        ; or -$2700
                        lsr.w   #1,d3
                        bcs.b   negative_coord
                        neg.w   d0
negative_coord:
                        ext.l   d0
                        divs.w  d2,d0
                        ; center both x & y
                        ; & compensate for $dff102 shift
                        add.w   #(SCREEN_X/2)-8,d0
max_zoom:
                        move.w  d0,-(a0)
                        rts

; ------------------------------------------------------------------
copperlist:
                        dc.w    $9a,$7fff,$96,$20
                        dc.w    $8e,$2c83,$90,$2cbf
                        dc.w    $92,$38,$94,$d0
                        ; sets here to make it stable
                        ; the (4*SCREEN_BYTES) is necessary on 2.0+
                        ; or there'll be some garbage at the top of
                        ; the screen (i don't know why)
                        dc.w    $e2,(4*SCREEN_BYTES)+(20*SCREEN_BYTES)
                        dc.w    $100,$1200
                        dc.w    $108,SCREEN_BYTES-40
                        dc.w    $180,0
                        dc.w    -1
                        align   2
fin:
                        dc.l    $000003f2
